import {CorporateUser, Group, User, Type} from "@/interfaces/user";
import axios from "axios";

export const isUserFromCorporate = async (userID: string) => {
	const groups = (await axios.get<Group[]>(`/api/groups?participant=${userID}`)).data;
	const users = (await axios.get<User[]>("/api/users/list")).data;

	const adminTypes = groups.map((g) => users.find((u) => u.id === g.admin)?.type);
	return adminTypes.includes("corporate");
};

const getAdminForGroup = async (userID: string, role: Type) => {
	const groups = (await axios.get<Group[]>(`/api/groups?participant=${userID}`)).data;

	const adminRequests = await Promise.all(
		groups.map(async (g) => {
			const userRequest = await axios.get<User>(`/api/users/${g.admin}`);
			if (userRequest.status === 200) return userRequest.data;
			return undefined;
		}),
	);

	const admins = adminRequests.filter((x) => x?.type === role);
	return admins.length > 0 ? (admins[0] as CorporateUser) : undefined;
};

export const getUserCorporate = async (userID: string): Promise<CorporateUser | undefined> => {
	const userRequest = await axios.get<User>(`/api/users/${userID}`);
	if (userRequest.status === 200) {
		const user = userRequest.data;
		if (user.type === "corporate") {
			return getAdminForGroup(userID, "mastercorporate");
		}
	}

	return getAdminForGroup(userID, "corporate");
};
